// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	CSVデータをフォームに展開する
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

const setCSVView = () => {
	let insert ="";
	let i = 0;
	let j = 0;
	csv_data_array.forEach(element => {
		insert +='<tr>';
		element.forEach((childElement) =>{
			if ((0 == i) || (0 == j)) {
				insert +=`<th>${childElement}</th>`;
			}
			else {
				insert +=`<td>${childElement}</td>`;
			}
			j ++;
		});
		insert +='</tr>';
		i ++;
		j = 0;
	});
	
	//HTMLに出力
	csvTable.innerHTML = insert;
}

// CSVデータ追加
const addCSVData = () => {

	const TEAM_NAME = jQuery("#pName1_00").val();
	let teamNo = jQuery("#pTeamNo1").val();
	if (("" == teamNo) && ("" == TEAM_NAME)) {return;}
	if (("" == teamNo) || (csv_data_array.length <= teamNo)) {
		teamNo = csv_data_array.length;
	}
	const insertData = [
		teamNo, TEAM_NAME, jQuery("#pNowName1").val(),
		jQuery("#pLogo1").val(), jQuery("#pComm100").val(), jQuery("#pImage1").val(),
		jQuery("#pName1_01").val(), jQuery("#pMemberBack1_01").val(), jQuery("#pName1_02").val(), jQuery("#pMemberBack1_02").val(),
		jQuery("#pName1_03").val(), jQuery("#pMemberBack1_03").val(), jQuery("#pName1_04").val(), jQuery("#pMemberBack1_04").val(),
		jQuery("#pName1_05").val(), jQuery("#pMemberBack1_05").val(), jQuery("#pName1_06").val(),
		jQuery("#pName1_07").val(), jQuery("#pName1_08").val(), jQuery("#pName1_09").val(),
		jQuery("#pName1_10").val(), jQuery("#pName1_11").val(), jQuery("#pName1_12").val(),
		jQuery("#pName1_13").val(), jQuery("#pName1_14").val(), jQuery("#pName1_15").val(),
		jQuery("#pName1_16").val(), jQuery("#pName1_17").val(), jQuery("#pName1_18").val(),
		jQuery("#pComm101").val(), jQuery("#pComm102").val(), jQuery("#pComm103").val(),
		jQuery("#pComm104").val(), jQuery("#pComm105").val(), jQuery("#pComm106").val(),
		jQuery("#pComm107").val(), jQuery("#pComm108").val(), jQuery("#pComm109").val(),
		jQuery("#pComm110").val(), jQuery("#pComm111").val(), jQuery("#pComm112").val(),
		jQuery("#pComm113").val(), jQuery("#pComm114").val(), jQuery("#pComm115").val(),
		jQuery("#pComm116").val(), jQuery("#pComm117").val(), jQuery("#pComm118").val()
	];
	// 追加
	if (teamNo == csv_data_array.length) {
		let fInsert = true;
		for (let i = 0; i < csv_autoComplete.length; i++) {
			if (TEAM_NAME == csv_autoComplete[i]) {
				fInsert = window.confirm(TEAM_NAME + "は既に No" + (i + 1) + " で登録済みですが、データを追加しますか？");
				break;
			}
		}
		if (fInsert) {
			csv_data_array.push(insertData);
		}
	}
	else {
		if (window.confirm(teamNo + "番を上書きします。よろしいですか？")) {
			if ("" == TEAM_NAME) {
				// 要素を削除し、番号を振り直す
				csv_data_array.splice(teamNo, 1);
				for (let i = 1; i < csv_data_array.length; i++ ) {
					csv_data_array[i][YMSB_CSV.NO_INDEX] = i;
				}
			}
			else {
				// 上書き
				csv_data_array[teamNo] = insertData;
			}
		}
	}

	// オートコンプリートのデータ設定
	setAutoComplete();
}

async function saveCSVFile() {
	let csvData = "";
	csv_data_array.forEach(function(rowArray) {
		let row = rowArray.join(",");
		csvData += row + "\r\n";
	});
	let blob = new Blob([csvData], {type: 'text/csv'});
	const writable = await CSVfileHandle.createWritable();
	await writable.write(blob);
	await writable.close();
}