// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
//
//	フォント・スキンクラス
//
// ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■

let currFont = 99;
let currSkin = 99;

// ■■ フォント設定 ■■
class YmsbFont {
	FONT_NAME				= 0;
	FONT_POS_TEAM_NAME		= 1;
	FONT_POS_NOW_NAME		= 2;
	FONT_POS_SCORE			= 3;
	
	constructor() {
		currFont = 99;
	}

	checkData() {
		let newFont = jsonData[SbJSON.FONT];
		if (currFont != newFont) {
			jQuery("body").css({"font-family":arrFonts[this.FONT_NAME][newFont]});

			// フォント変更による位置の微調整
			for (let i = 0; i < 2; i++) {
				jQuery(arrCSSTxtTeam[i] ).css({"top":arrFonts[this.FONT_POS_TEAM_NAME][newFont]});
				jQuery(arrCSSTxtNow[i]  ).css({"top":arrFonts[this.FONT_POS_NOW_NAME][newFont]});
				jQuery(arrCSSTxtScore[i]).css({"top":arrFonts[this.FONT_POS_SCORE][newFont]});
			}
			currFont = newFont;
		}
	}
}

// ■■ スキン設定 ■■
class YmsbSkin {
		SKIN_NUMBER					=  0;
		SKIN_SCORE_COLOR_TXT_1P		=  1;
		SKIN_SCORE_COLOR_TXT_2P		=  2;
		SKIN_NEXT_COLOR_1P			=  3;
		SKIN_NEXT_COLOR_2P			=  4;
		SKIN_NEXT_BORDER_COLOR_1P	=  5;
		SKIN_NEXT_BORDER_COLOR_2P	=  6;
		SKIN_MEMBER_BOX_NOW_1P		=  7;
		SKIN_MEMBER_BOX_NOW_2P		=  8;
		SKIN_MEMBER_BOX_1P			=  9;
		SKIN_MEMBER_BOX_2P			= 10;
		SKIN_MEMBER_BOX_BORDER_1P	= 11;
		SKIN_MEMBER_BOX_BORDER_2P	= 12;
		SKIN_MEMBER_BOX_RADIUS_1P	= 13;
		SKIN_MEMBER_BOX_RADIUS_2P	= 14;
		SKIN_COLOR_FONT				= 15;
		SKIN_COLOR_FONT_SHADE		= 16;

		/// 団体戦メンバー文字色/影色
		FONT_COLOR_MEM_WIN		= "#eee";	
		FONT_COLOR_MEM_LOS		= "#222";	
		FONT_COLOR_MEM_NOW		= this.FONT_COLOR_MEM_WIN;	
		FONT_SHADE_MEM_WIN		= "#000";
		FONT_SHADE_MEM_LOS		= "#FFF";
		FONT_SHADE_MEM_NOW		= "#660";

		BORDER_COLOR_MEM_NOW	= "#F33";					// 団体戦メンバーの枠色　（プレイ中）
		BG_COLOR_MEM_LOS		= "#000";					// 団体戦メンバーの背景色（敗退）
		
		PARAM_BORDER_SIDE			= "10px solid ";
		PARAM_BORDER_BOTTOM			= "0px solid ";
//		PARAM_FONTSHADE				= "5px 5px 3px ";
		PARAM_FONTSHADE				= "2px 2px 2px ";
// 		PARAM_FONTSHADE				= "2px 2px 0px #000, -2px 2px 0px #000, 2px -2px 0px #000, -2px -2px 0px ";

		arrColorScoreTxt			= [this.SKIN_SCORE_COLOR_TXT_1P,	this.SKIN_SCORE_COLOR_TXT_2P];
		arrColorNext				= [this.SKIN_NEXT_COLOR_1P,			this.SKIN_NEXT_COLOR_2P];
		arrColorNextBorder			= [this.SKIN_NEXT_BORDER_COLOR_1P,	this.SKIN_NEXT_BORDER_COLOR_2P];
		arrColorMemberBox			= [this.SKIN_MEMBER_BOX_1P,			this.SKIN_MEMBER_BOX_2P];
		arrColorMemberBoxNow		= [this.SKIN_MEMBER_BOX_NOW_1P,		this.SKIN_MEMBER_BOX_NOW_2P];
		arrColorMemberBorder		= [this.SKIN_MEMBER_BOX_BORDER_1P,	this.SKIN_MEMBER_BOX_BORDER_2P];
		arrRadiusMemberBorder		= [this.SKIN_MEMBER_BOX_RADIUS_1P,	this.SKIN_MEMBER_BOX_RADIUS_2P];

	constructor() {
		currSkin			= 99;
		this.currStingerImage	= "";
		this.currStingerWindow	= "";
	}

	get defStingerBack() {
		return this.currStingerImage;
	}

	get defStingerWindow() {
		return this.currStingerWindow;
	}

	checkData() {
		let newSkin	= jsonData[SbJSON.SKIN];
		if (currSkin != newSkin) {
			// 画像ファイル更新
			let skinNumber = YMSB_URL_IMG + arrSkin[this.SKIN_NUMBER][newSkin];
			jQuery(SbCSS.BOX_BACKGROUND     ).attr("src", skinNumber + "BoxBack.png");
			jQuery(SbCSS.BOX_BACK_CENTER_DEF).attr("src", skinNumber + "BoxStingerBack.png");
			jQuery(SbCSS.BOX_STINGER_WINDOW ).attr("src", skinNumber + "BoxStingerWindow.png");
			jQuery(SbCSS.BOX_STAGE          ).attr("src", skinNumber + "BoxStage.png");
			jQuery(SbCSS.BOX_EVENT          ).attr("src", skinNumber + "BoxEvent.png");
			jQuery(SbCSS.BOX_EVENT_01       ).attr("src", skinNumber + "BoxEvent.png");
			jQuery(SbCSS.BOX_EVENT_02       ).attr("src", skinNumber + "BoxEvent.png");
			jQuery(SbCSS.BOX_TEAM_1P        ).attr("src", skinNumber + "BoxTeam1p.png");
			jQuery(SbCSS.BOX_TEAM_2P        ).attr("src", skinNumber + "BoxTeam2p.png");
			jQuery(SbCSS.BOX_SCORE_1P		).attr("src", skinNumber + "BoxScore1p.png");
			jQuery(SbCSS.BOX_SCORE_2P		).attr("src", skinNumber + "BoxScore2p.png");
			jQuery(SbCSS.BOX_NOW_1P         ).attr("src", skinNumber + "BoxNow1p.png");
			jQuery(SbCSS.BOX_NOW_2P         ).attr("src", skinNumber + "BoxNow2p.png");
			jQuery(SbCSS.BOX_STAR_1P		).attr("src", skinNumber + "BoxStar1p.png");
			jQuery(SbCSS.BOX_STAR_2P		).attr("src", skinNumber + "BoxStar2p.png");
			jQuery(SbCSS.BOX_COMMENT_1P     ).attr("src", skinNumber + "BoxComment1p.png");
			jQuery(SbCSS.BOX_COMMENT_2P     ).attr("src", skinNumber + "BoxComment2p.png");
			jQuery(SbCSS.BOX_FT10_BACK      ).attr("src", skinNumber + "BoxFT10Back.png");

			// スティンガーのデフォルト設定
			this.currStingerImage	= skinNumber + "BoxStingerBack.png";
			this.currStingerWindow	= skinNumber + "BoxStingerWindow.png";
			jQuery(SbCSS.BOX_BACK_CENTER   ).css("background-image" , "url(" + this.currStingerImage  + ")");
			jQuery(SbCSS.BOX_STINGER_WINDOW).css("background-image" , "url(" + this.currStingerWindow + ")");
			jQuery(SbCSS.TXT_STINGER_VS).text(YmsbAnime.fitTextWidth(SB_TXT_VS, SbCSS.TXT_STINGER_VS));
			jQuery(SbCSS.TXT_STINGER_NEXT_CENTER).text(YmsbAnime.fitTextWidth(SB_TXT_STINGER_NEXT_CENTER, SbCSS.TXT_STINGER_NEXT_CENTER));

			// CSS更新
			jQuery(SbCSS.TXT_STAGE).css  ({"color"           : arrSkin[this.SKIN_COLOR_FONT][newSkin],
										   "text-shadow"     : this.PARAM_FONTSHADE + arrSkin[this.SKIN_COLOR_FONT_SHADE][newSkin]});
			let newMaxLives		= jsonData[SbJSON.MAX_MEMBER_LIVES];

			for (let i = 0; i < 2; i++) {
				let borderParamSide   = this.PARAM_BORDER_SIDE   + arrSkin[this.arrColorMemberBorder[i]][newSkin];
				let borderParamBottom = this.PARAM_BORDER_BOTTOM + arrSkin[this.arrColorMemberBorder[i]][newSkin];
				let borderParamRadius = arrSkin[this.arrRadiusMemberBorder[i]][newSkin];
				let newOrder = jsonData[arrJSONOrder[i]] - 1;

				for (let j = 0; j < YMSB_MAX_PLAYER; j++) {
					if ("" != jsonData[arrTxtMemberJSON[i][j]]) {
						let memberColor = arrSkin[this.arrColorMemberBox[i]][newSkin];;
						let pDead = jsonData[arrPrmDeadJSON[i][j]];
						let newLife = jsonData[arrPrmLifeJSON[i][j]];

						if (newOrder == j) {
							pDead = YMSB_NOW_PLAYING;	
						}
						else if (0 == newLife && 0 != newMaxLives) {
							pDead = YMSB_ON;
						}
						else {
							// nop
						}
						borderParamSide = this.PARAM_BORDER_SIDE + arrSkin[this.arrColorMemberBorder[i]][newSkin];

						if (YMSB_ON == pDead) {
							memberColor = this.BG_COLOR_MEM_LOS;
						}
						else if (YMSB_NOW_PLAYING == pDead) {
							borderParamSide = this.PARAM_BORDER_SIDE + arrSkin[this.arrColorMemberBoxNow[i]][newSkin];
						}
						else {
							// nop
						}
						jQuery(arrBoxMemberCSS[i][j]).css({
							"background-color":memberColor,
							"border-bottom": borderParamBottom,
							"border-left"  : borderParamSide,
							"border-right" : borderParamSide,
							"border-radius": borderParamRadius
							});
						jQuery(arrBoxMemberLifeCSS[i][j]).css({
							"background-color":memberColor,
							"border": borderParamBottom,
						});
					}
				}
				jQuery(arrCSSTxtTeam[i] ).css({
											"color"           : arrSkin[this.SKIN_COLOR_FONT][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE + arrSkin[this.SKIN_COLOR_FONT_SHADE][newSkin]});
				jQuery(arrCSSTxtEvent[i]).css({
											"color"           : arrSkin[this.SKIN_COLOR_FONT][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE + arrSkin[this.SKIN_COLOR_FONT_SHADE][newSkin]});
				jQuery(arrCSSTxtNow[i]).css  ({
											"color"           : arrSkin[this.SKIN_COLOR_FONT][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE + arrSkin[this.SKIN_COLOR_FONT_SHADE][newSkin]});
				jQuery(arrCSSTxtScore[i]).css({
											"color"           : arrSkin[this.arrColorScoreTxt[i]][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE + arrSkin[this.SKIN_COLOR_FONT_SHADE][newSkin]});
				jQuery(arrCSSTxtStar[i]).css({
											"color"           : arrSkin[this.arrColorScoreTxt[i]][newSkin],
											"text-shadow"     : this.PARAM_FONTSHADE + arrSkin[this.SKIN_COLOR_FONT_SHADE][newSkin]});
				jQuery(arrCSSTxtStingerNext[i]).css({
											"color"           : arrSkin[this.arrColorNext[i]][newSkin],
											"text-stroke"     : this.BORDER_SIZE_NEXT + arrSkin[this.arrColorNextBorder[i]][newSkin]});
				borderParamSide = this.PARAM_BORDER_SIDE + arrSkin[this.arrColorMemberBorder[i]][newSkin];
				jQuery(arrCSSBoxNext[i]).css({
											"background-color": arrSkin[this.arrColorMemberBox[i]][newSkin],
											"border-bottom"   : borderParamBottom,
											"border-left"     : borderParamSide,
											"border-right"    : borderParamSide,
											"border-radius"   : borderParamRadius});

			}
			currSkin = newSkin;
		}
	}
}
